Package ghidra.framework.plugintool.util

# Class PluginPackage

java.lang.Object
ghidra.framework.plugintool.util.PluginPackage

All Implemented Interfaces:
  `ExtensionPoint`, `Comparable<PluginPackage>`

Direct Known Subclasses:
  `BsimPluginPackage`, `CorePluginPackage`, `DeveloperPluginPackage`, `ExamplesPluginPackage`, `MiscellaneousPluginPackage`, `UtilityPluginPackage`

public abstract class PluginPackage extends Object implements ExtensionPoint, Comparable<PluginPackage>

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final int`
  `CORE_PRIORITY`
  `static final int`
  `DEVELOPER_PRIORITY`
  `static final int`
  `EXAMPLES_PRIORITY`
  `static final int`
  `EXPERIMENTAL_PRIORITY`
  `static final int`
  `FEATURE_PRIORITY`
  `static final int`
  `MISCELLANIOUS_PRIORITY`
  `static final int`
  `UTILITY_PRIORITY`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `PluginPackage(String name, Icon icon, String description)`
  `protected`
  `PluginPackage(String name, Icon icon, String description, int priority)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `compareTo(PluginPackage other)`
  `static boolean`
  `exists(String packageName)`
  Returns true if the system has found a plugin package for the given name
  `PluginStatus`
  `getActivationLevel()`
  The minimum level required to activate plugins when the entire package is activated by the user.
  `String`
  `getDescription()`
  `Icon`
  `getIcon()`
  `String`
  `getName()`
  `static PluginPackage`
  `getPluginPackage(String packageName)`
  Returns the existing plugin package with the given name.
  `String`
  `toString()`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### UTILITY_PRIORITY

    public static final int UTILITY_PRIORITY
    See Also:
      - Constant Field Values

  - ### CORE_PRIORITY

    public static final int CORE_PRIORITY
    See Also:
      - Constant Field Values

  - ### FEATURE_PRIORITY

    public static final int FEATURE_PRIORITY
    See Also:
      - Constant Field Values

  - ### MISCELLANIOUS_PRIORITY

    public static final int MISCELLANIOUS_PRIORITY
    See Also:
      - Constant Field Values

  - ### DEVELOPER_PRIORITY

    public static final int DEVELOPER_PRIORITY
    See Also:
      - Constant Field Values

  - ### EXAMPLES_PRIORITY

    public static final int EXAMPLES_PRIORITY
    See Also:
      - Constant Field Values

  - ### EXPERIMENTAL_PRIORITY

    public static final int EXPERIMENTAL_PRIORITY
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### PluginPackage

    protected PluginPackage(String name, Icon icon, String description)

  - ### PluginPackage

    protected PluginPackage(String name, Icon icon, String description, int priority)

- ## Method Details

  - ### exists

    public static boolean exists(String packageName)
    Returns true if the system has found a plugin package for the given name
    Parameters:
      `packageName` - the package name
    Returns:
      true if the system has found a plugin package for the given name

  - ### getPluginPackage

    public static PluginPackage getPluginPackage(String packageName)
    Returns the existing plugin package with the given name. If no package exists, then the `MiscellaneousPluginPackage` will be returned.
    Parameters:
      `packageName` - the package name
    Returns:
      the package

  - ### getName

    public String getName()

  - ### getIcon

    public Icon getIcon()

  - ### getDescription

    public String getDescription()

  - ### getActivationLevel

    public PluginStatus getActivationLevel()
    The minimum level required to activate plugins when the entire package is activated by the user.
    Returns:
      the minimum level

  - ### compareTo

    public int compareTo(PluginPackage other)
    Specified by:
      `compareTo` in interface `Comparable<PluginPackage>`

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Object`